﻿using MindFusion.Charting;
using MindFusion.Drawing;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace PieChart
{
	// Learn more about making custom code visible in the Xamarin.Forms previewer
	// by visiting https://aka.ms/xamarinforms-previewer
	[DesignTimeVisible(false)]
	public partial class MainPage : ContentPage
	{
		public MainPage()
		{
			InitializeComponent();

            pieChart.BackgroundColor = Colors.White;
            pieChart.ShowLegend = false;
            pieChart.Theme.DataLabelsBrush = new SolidBrush(Color.FromRgb(100, 100, 100));
            pieChart.Theme.DataLabelsFontSize = 14;

            var values = new List<double> { 20, 30, 10, 40 };
            pieChart.Series = new PieSeries(
                values,
                new List<string>
                {
                    "20", "30", "10", "40"
                },
                new List<string>
                {
                    "twenty", "thirty", "ten", "forty"
                }
            );

            pieChart.Plot.SeriesStyle = new PerElementSeriesStyle
            {
                Fills = new List<List<MindFusion.Drawing.Brush>>
                {
                    new List<Brush>
                    {
                        new SolidBrush(Color.FromRgb(156, 170, 198)),
                        new SolidBrush(Color.FromRgb(192, 192, 192)),
                        new SolidBrush(Color.FromRgb(0, 52, 102)),
                        new SolidBrush(Color.FromRgb(206, 0, 0))
                    }
                },
                Strokes = new List<List<MindFusion.Drawing.Brush>>
                {
                    new List<Brush>
                    {
                        new SolidBrush(Color.FromRgb(224, 233, 233))                      
                    }
                },
                StrokeThicknesses = new List<List<double>>
                {
                    new List<double>
                    {
                        3.0
                    }
                }
            };
        }

        void cbDonut_Toggled(object sender, ToggledEventArgs e)
        {
            pieChart.Doughnut = !pieChart.Doughnut;
            pieChart.Invalidate();
        }

        void cbShowDataLabels_Toggled(object sender, ToggledEventArgs e)
        {
            if (cbShowDataLabels.IsToggled)
                pieChart.ShowDataLabels = LabelKinds.All;
            else
                pieChart.ShowDataLabels = LabelKinds.None;
            pieChart.Invalidate();
        }
    }
}